#include <stdlib.h>
#include <stdint.h>

void cdiDecodeParam(int param, int *pnum, int *pdis, int *pcat)
{
  int iparam;

  iparam = param;
  if ( param < 0 ) iparam = -iparam;
  *pdis  =  iparam / 1000000;
  iparam  = iparam - *pdis*1000000;
  *pcat = iparam / 1000;
  *pnum = iparam - *pcat*1000;
  if ( param < 0 ) *pnum = -(*pnum);
}


int cdiEncodeParam(int pnum, int pcat, int pdis)
{
  int param;
  int inum;

  inum = pnum;
  if ( pnum < 0 ) inum = -pnum;
  param = pdis*1000000 + pcat*1000 + inum;
  if ( pnum < 0 ) param = -param;

  return (param);
}


void cdiDecodeDate(int64_t date, int *year, int *month, int *day)
{
  int64_t iyear = (int)(date / 10000);
  *year = (int)iyear;
  int64_t idate = date - iyear * 10000;
  if ( idate < 0 ) idate = -idate;
  int64_t imonth = idate / 100;
  *month = (int)imonth;
  *day   = (int)(idate - imonth * 100);
}


int64_t cdiEncodeDate(int year, int month, int day)
{
  int64_t iyear = abs(year);
  int64_t date = iyear * 10000 + month * 100 + day;
  if ( year < 0 ) date = -date;

  return date;
}


void cdiDecodeTime(int time, int *hour, int *minute, int *second)
{
  int itime;

  *hour   = time / 10000;
  itime   = time - *hour*10000;
  *minute = itime / 100;
  *second = itime - *minute*100;
}


int cdiEncodeTime(int hour, int minute, int second)
{
  int time;

  time = hour*10000 + minute*100 + second;

  return (time);
}
